/********************************************************************
 Mod5282 LED Display example program.
 This program demonstrates how to write to the 7-segment display on
 the 5282 carrier development board. The program will repeatedly 
 count from 0 to 9999.
 
 Initial release, 6/10/2003
 *******************************************************************/
#include "predef.h"
#include <stdio.h>
#include <ctype.h>
#include <startnet.h>
#include <autoupdate.h>
#include <dhcpclient.h>

extern "C" {
	void UserMain(void * pd);
}


/* Use the putdisp() function to pass in the value you want 
   to see on the display. For example, a hex value of 0x1234 
   will be seen as 1234 on the LED display. A nibble value of 
   F will blank (clear) a digit.Nibble values of 0xA to E are 
   undefined.
*/
extern "C" {
	void putdisp(unsigned short w);
}


/* Helper function to display a decimal number */
void PutDispDecimal(WORD val, BOOL blank_zero )
{
	WORD w;
	
	w=(val / 1000) * 0x1000;
	if ((w==0) && (blank_zero)) w=0xF000;
	
	w+=((val / 100)% 10) * 0x0100;
	if (w==0xF000) w=0xFF00;
	
	w+=((val / 10)% 10) * 0x0010;
	if (w==0xFF00) w=0xFFF0;
	
	w+=((val )% 10) * 0x0001;
	
	putdisp(w);
}


/********************************************************************
 UserMain
********************************************************************/
void UserMain(void * pd)
{
	InitializeStack();
	if (EthernetIP == 0)
		GetDHCPAddress();
	OSChangePrio(MAIN_PRIO);
	EnableAutoUpdate();
	
	iprintf("Application started\n");
	while (1)
	{
		for (int i=0; i< 9999; i++)
        {
           PutDispDecimal(i, TRUE);
           OSTimeDly(1);
		}
	}
}
